<solidify-empty-container [solidifyFocusFirstElement]="true"
                          cdkTrapFocus
>
  <solidify-button-toolbar-detail (deleteChange)="delete()"
                                  (showHistoryChange)="showHistory()"
                                  [currentModel]="$any(getData())"
                                  [deleteAvailable]="canDelete"
                                  [editAvailable]="false"
                                  [backToListNavigate]="backToListNavigate()"
                                  [historyAvailable]="(data.statusHistoryNamespace | isNotNullNorUndefined) && (data.statusHistoryState | isNotNullNorUndefined)"
                                  [listExtraButtons]="data.buttons"
                                  [listExtraSmallButtons]="smallButtons"
                                  [mode]="'detail'"
                                  [saveAvailable]="false"
  >
  </solidify-button-toolbar-detail>

  <div class="container">

    <ng-template [ngTemplateOutlet]="visualizationTemplate"></ng-template>

    <div class="informations">

      <ng-template [ngTemplateOutlet]="infoTemplate"></ng-template>

      <ng-template [ngTemplateOutlet]="checkSumAnalysisVirusTemplate"></ng-template>

      <dlcm-shared-additional-information-panel-container [resource]="getData()"
      ></dlcm-shared-additional-information-panel-container>

    </div>

  </div>

</solidify-empty-container>


<!--TEMPLATE BELOW-->

<ng-template #visualizationTemplate>
  <div *ngIf="previewAvailable; else noPreviewAvailable;"
       [class.fullscreen]="isInFullscreenMode"
       class="visualization"
  >
    <div *ngIf="previewAvailable && !isInFullscreenMode && (fullScreenObs | async)"
         class="fullscreen-button-wrapper"
    >
      <button (click)="enterFullScreen()"
              [matTooltip]="labelTranslateEnum.fullscreen | translate"
              class="fullscreen-button"
              mat-icon-button
              type="button"
      >
        <solidify-icon [iconName]="iconNameEnum.fullScreenEnter"></solidify-icon>
      </button>
    </div>
    <solidify-file-visualizer (errorMessageChange)="visualizationErrorMessage = $event"
                              (fullScreenAvailableChange)="changeFullScreen($event)"
                              [class.has-error-message]="visualizationErrorMessage"
                              [fileToVisualize]="getFileInput()"
                              [zoomEnable]="zoomEnable"
                              [fileDownloadUrl]="fileDownloadUrl"
                              class="file-visualizer"
    ></solidify-file-visualizer>
    <div *ngIf="visualizationErrorMessage"
         class="warning-area"
    >
      <solidify-icon [iconName]="iconNameEnum.warning"
                     class="tab-header-icon size-50"
      ></solidify-icon>
      <div class="visualization-error-message">{{visualizationErrorMessage | translate}}</div>
    </div>
  </div>

  <ng-template #noPreviewAvailable>
    <div class="no-preview">
      <div *ngIf="data.mode === modeEnum.aip ||
      (asDataFile(getData()).dataCategory === dataCategoryEnum.PACKAGE && asDataFile(getData()).dataType === dataTypeEnum.INFORMATION_PACKAGE); else
      previewNoFile"
           class="package"
      >
        {{getLogoPackage()}}
      </div>

      <ng-template #previewNoFile>
        <span *ngIf="asDataFile(getData()).status === statusEnum.CHANGE_RELATIVE_LOCATION; else previewNoFileIcon"
              class="no-preview-change-relative-location"
        >{{
                labelTranslateEnum.cannotPreviewWhileMovingTheFile |
                    translate
          }}</span>
        <ng-template #previewNoFileIcon>
          <div class="visualization-no-preview">
            <solidify-icon [iconName]="iconNameEnum.noPreview"
                           class="icon"
            ></solidify-icon>
            <div *ngIf="visualizationErrorMessage | isNotNullNorUndefinedNorWhiteString"
                 class="visualization-error-message"
            >{{visualizationErrorMessage | translate}}
            </div>
            <div *ngIf="canDownload && !readyForDownload && (visualizationErrorMessage | isNullOrUndefinedOrWhiteString)"
                 class="trigger-preview-wrapper"
            >
              <button class="trigger-preview"
                      mat-flat-button
                      (click)="triggerPreview()"
              >{{labelTranslateEnum.preview | translate}}
              </button>
            </div>
          </div>
        </ng-template>
      </ng-template>
    </div>

  </ng-template>

</ng-template>

<ng-template #checkSumAnalysisVirusTemplate>
  <solidify-panel-expandable *ngIf="(getData().checksums | isNotNullNorUndefined) && (getData().checksums | isNonEmptyArray)"
                             [isOpen]="true"
                             [titleToTranslate]="'deposit.file.details.delimiter.checksum' | translate"
  >
    <dlcm-shared-checksum [checksums]="getData().checksums"></dlcm-shared-checksum>
  </solidify-panel-expandable>

  <solidify-panel-expandable *ngIf="getData().fileFormat?.tool | isNotNullNorUndefined"
                             [titleToTranslate]="'deposit.file.details.delimiter.analyticalTool' | translate"
  >
    <mat-list>
      <ng-template [ngIf]="getData()?.fileFormat?.tool?.name | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.name' | translate}}</span>
            <span class="value">{{getData().fileFormat.tool.name}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.fileFormat?.tool?.version | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.version' | translate}}</span>
            <span class="value">{{getData().fileFormat.tool.version}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.fileFormat?.tool?.description | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.description' | translate}}</span>
            <span class="value">{{getData().fileFormat.tool.description}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.fileFormat?.tool?.puid | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.puid' | translate}}</span>
            <span class="value"><a [href]="getPuidLink(getData().fileFormat.tool.puid)"
                                   target="_blank"
            >{{getData().fileFormat.tool.puid}}</a></span>
          </div>
        </mat-list-item>
      </ng-template>
    </mat-list>
  </solidify-panel-expandable>

  <solidify-panel-expandable *ngIf="getData()?.virusCheck | isNotNullNorUndefined"
                             [titleToTranslate]="'deposit.file.details.delimiter.antivirus' | translate"
  >
    <mat-list>
      <ng-template [ngIf]="getData()?.virusCheck?.tool?.name | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.name' | translate}}</span>
            <span class="value">{{getData().virusCheck.tool.name}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.virusCheck?.tool?.description | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.description' | translate}}</span>
            <span class="value">{{getData().virusCheck.tool.description}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.virusCheck?.tool?.version | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.version' | translate}}</span>
            <span class="value">{{getData().virusCheck.tool.version}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.virusCheck?.tool?.puid | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.tool.puid' | translate}}</span>
            <span class="value"><a [href]="getPuidLink(getData().virusCheck.tool.puid)"
                                   target="_blank"
            >{{getData().virusCheck.tool.puid}}</a></span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.virusCheck?.checkDate | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.virusCheck.checkDate' | translate}}</span>
            <span class="value">{{dateUtil.convertDateToDateTimeString($any(getData().virusCheck.checkDate))}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <ng-template [ngIf]="getData()?.virusCheck?.details | isNotNullNorUndefined">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.virusCheck.details' | translate}}</span>
            <span class="value">{{getData().virusCheck.details}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>
    </mat-list>
  </solidify-panel-expandable>
</ng-template>

<ng-template #infoTemplate>
  <solidify-panel-expandable [isOpen]="true"
                             [titleToTranslate]="'deposit.file.details.delimiter.fileInfo' | translate"
  >
    <mat-list>
      <mat-list-item>
        <div class="item-content">
          <span class="key">{{'deposit.file.detail.data.fileName' | translate}}</span>
          <span [title]="getDataFileName()"
                class="value"
          >{{getDataFileName()}}</span>
        </div>
      </mat-list-item>
      <mat-divider></mat-divider>

      <ng-template [ngIf]="data.mode === modeEnum.file">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.location' | translate}}</span>
            <span class="value">{{data.dataFile.relativeLocation}}</span>
            <button (click)="editLocation()"
                    (onEnter)="editLocation()"
                    *ngIf="canEdit"
                    aria-label="Edit location"
                    class="edit"
                    mat-icon-button
                    solidifyShortCuts
                    type="button"
            >
              <solidify-icon [iconName]="iconNameEnum.edit"></solidify-icon>
            </button>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>
      </ng-template>

      <mat-list-item>
        <div class="item-content">
          <span class="key">{{'deposit.file.detail.data.smartSize' | translate}}</span>
          <span class="value">{{asDataFile(getData()).smartSize}}</span>
        </div>
      </mat-list-item>
      <mat-divider></mat-divider>

      <ng-template [ngIf]="data.mode === modeEnum.file">
        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.category' | translate}}</span>
            <span class="value"
                  solidifyTooltipOnEllipsis
            >{{enumUtil.getLabel(enumsDataCategoryAndType.DataCategoryEnumTranslate, data.dataFile.dataCategory) | translate}}</span>
            <button (click)="editCategory()"
                    (onEnter)="editCategory()"
                    *ngIf="canEdit"
                    aria-label="Edit location"
                    class="edit"
                    mat-icon-button
                    solidifyShortCuts
                    type="button"
            >
              <solidify-icon [iconName]="iconNameEnum.edit"></solidify-icon>
            </button>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>

        <mat-list-item>
          <div class="item-content">
            <span class="key">{{'deposit.file.detail.data.type' | translate}}</span>
            <span class="value"
                  solidifyTooltipOnEllipsis
            >{{enumUtil.getLabel(enumsDataCategoryAndType.DataTypeEnumTranslate, data.dataFile.dataType) | translate}}</span>
          </div>
        </mat-list-item>
        <mat-divider></mat-divider>

        <ng-container *ngIf="data.dataFile.metadataType?.fullName as fullName">
          <mat-list-item>
            <div class="item-content">
              <span class="key">{{'deposit.file.detail.data.metadataType' | translate}}</span>
              <span [title]="fullName"
                    class="value"
              >{{fullName}}</span>
            </div>
          </mat-list-item>
          <mat-divider></mat-divider>
        </ng-container>
      </ng-template>

      <ng-container *ngIf="getData().fileFormat !== null">

        <ng-container *ngIf="getData()?.fileFormat?.contentType as contentType">
          <mat-list-item>
            <div class="item-content">
              <span class="key">{{'deposit.file.detail.data.mimeType' | translate}}</span>
              <span [title]="contentType"
                    class="value"
              >{{contentType}}</span>
            </div>
          </mat-list-item>
          <mat-divider></mat-divider>
        </ng-container>

        <ng-container *ngIf="getData()?.fileFormat?.format as format">
          <mat-list-item>
            <div class="item-content">
              <span class="key">{{'deposit.file.detail.data.fileFormat' | translate}}</span>
              <span [title]="format"
                    class="value"
              >{{format}}</span>
            </div>
          </mat-list-item>
          <mat-divider></mat-divider>
        </ng-container>

        <ng-container *ngIf="getData()?.fileFormat?.puid as puid">
          <mat-list-item>
            <div class="item-content">
              <span class="key">{{'deposit.file.detail.data.puid' | translate}}</span>
              <span [title]="puid"
                    class="value"
              ><a [href]="getPuidLink(puid)"
                  target="_blank"
              >{{puid}}</a></span>
            </div>
          </mat-list-item>
          <mat-divider></mat-divider>
        </ng-container>
      </ng-container>

      <mat-list-item>
        <div class="item-content">
          <span class="key">{{labelTranslateEnum.complianceLevel | translate}}</span>
          <span class="value">
            <dlcm-shared-compliance-level-rating [value]="getComplianceLevel()"
                                                 [withLabel]="false"
            ></dlcm-shared-compliance-level-rating>
          </span>
        </div>
      </mat-list-item>
      <mat-divider></mat-divider>
    </mat-list>
  </solidify-panel-expandable>
</ng-template>
